package chapter05;

import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantReadWriteLock;

/**
 * 10-19
 */
public class ProcessData {
    private static final ReentrantReadWriteLock rwl       = new ReentrantReadWriteLock();
    private static final Lock                   readLock  = rwl.readLock();
    private static final Lock                   writeLock = rwl.writeLock();
    private volatile boolean                    update    = false;

    public void processData() {
        readLock.lock();
        if (!update) {
            // ͷŶ
            readLock.unlock();
            // дȡʼ
            writeLock.lock();
            try {
                if (!update) {
                    // ׼ݵ̣ԣ
                    update = true;
                }
                readLock.lock();
            } finally {
                writeLock.unlock();
            }
            // ɣдΪ
        }
        try {
            // ʹݵ̣ԣ
        } finally {
            readLock.unlock();
        }
    }

}
